<template>
  <div class="container">
    <template v-if="$fetchState.pending"> Loading ... </template>
    <template v-else-if="$fetchState.error">
      <AppError :error="$fetchState.error" />
    </template>
    <template v-else>
      <AppFilter />
      <CountryList :items="countriesList" />
    </template>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
export default {
  async fetch() {
    if (!this.$store.state.countries.countriesList.length) {
      await this.$store
        .dispatch('countries/fetchCountriesList')
        .catch((error) => {
          this.$sentry.captureException(new Error(error + ' index'))
          if (process.server) {
            this.$nuxt.context.res.statusCode = 404
          }
          throw new Error('Countries Not Found !')
          // throw new Error(error)
        })
    }
  },
  computed: {
    ...mapGetters({
      countriesList: 'countries/getCountriesListFilter',
    }),
  },
  head() {
    return {
      title: 'Home',
    }
  },
}
</script>

<style></style>
